package com.technical.test.mandiri.Database.Model;

import android.database.Cursor;
import android.database.sqlite.SQLiteStatement;

import org.greenrobot.greendao.AbstractDao;
import org.greenrobot.greendao.Property;
import org.greenrobot.greendao.internal.DaoConfig;
import org.greenrobot.greendao.database.Database;
import org.greenrobot.greendao.database.DatabaseStatement;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "CATEGORIES".
*/
public class CategoriesDao extends AbstractDao<Categories, String> {

    public static final String TABLENAME = "CATEGORIES";

    /**
     * Properties of entity Categories.<br/>
     * Can be used for QueryBuilder and for referencing column names.
     */
    public static class Properties {
        public final static Property CategoryId = new Property(0, String.class, "categoryId", true, "CATEGORY_ID");
        public final static Property SourceId = new Property(1, String.class, "sourceId", false, "SOURCE_ID");
        public final static Property SourceName = new Property(2, String.class, "sourceName", false, "SOURCE_NAME");
        public final static Property Author = new Property(3, String.class, "author", false, "AUTHOR");
        public final static Property Title = new Property(4, String.class, "title", false, "TITLE");
        public final static Property Desctiption = new Property(5, String.class, "desctiption", false, "DESCTIPTION");
        public final static Property Url = new Property(6, String.class, "url", false, "URL");
        public final static Property UrlToImage = new Property(7, String.class, "urlToImage", false, "URL_TO_IMAGE");
        public final static Property PublishedAt = new Property(8, String.class, "publishedAt", false, "PUBLISHED_AT");
        public final static Property Content = new Property(9, String.class, "content", false, "CONTENT");
        public final static Property CategoryRecord = new Property(10, Long.class, "categoryRecord", false, "CATEGORY_RECORD");
    }


    public CategoriesDao(DaoConfig config) {
        super(config);
    }
    
    public CategoriesDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(Database db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"CATEGORIES\" (" + //
                "\"CATEGORY_ID\" TEXT PRIMARY KEY NOT NULL ," + // 0: categoryId
                "\"SOURCE_ID\" TEXT," + // 1: sourceId
                "\"SOURCE_NAME\" TEXT," + // 2: sourceName
                "\"AUTHOR\" TEXT," + // 3: author
                "\"TITLE\" TEXT," + // 4: title
                "\"DESCTIPTION\" TEXT," + // 5: desctiption
                "\"URL\" TEXT," + // 6: url
                "\"URL_TO_IMAGE\" TEXT," + // 7: urlToImage
                "\"PUBLISHED_AT\" TEXT," + // 8: publishedAt
                "\"CONTENT\" TEXT," + // 9: content
                "\"CATEGORY_RECORD\" INTEGER);"); // 10: categoryRecord
    }

    /** Drops the underlying database table. */
    public static void dropTable(Database db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"CATEGORIES\"";
        db.execSQL(sql);
    }

    @Override
    protected final void bindValues(DatabaseStatement stmt, Categories entity) {
        stmt.clearBindings();
 
        String categoryId = entity.getCategoryId();
        if (categoryId != null) {
            stmt.bindString(1, categoryId);
        }
 
        String sourceId = entity.getSourceId();
        if (sourceId != null) {
            stmt.bindString(2, sourceId);
        }
 
        String sourceName = entity.getSourceName();
        if (sourceName != null) {
            stmt.bindString(3, sourceName);
        }
 
        String author = entity.getAuthor();
        if (author != null) {
            stmt.bindString(4, author);
        }
 
        String title = entity.getTitle();
        if (title != null) {
            stmt.bindString(5, title);
        }
 
        String desctiption = entity.getDesctiption();
        if (desctiption != null) {
            stmt.bindString(6, desctiption);
        }
 
        String url = entity.getUrl();
        if (url != null) {
            stmt.bindString(7, url);
        }
 
        String urlToImage = entity.getUrlToImage();
        if (urlToImage != null) {
            stmt.bindString(8, urlToImage);
        }
 
        String publishedAt = entity.getPublishedAt();
        if (publishedAt != null) {
            stmt.bindString(9, publishedAt);
        }
 
        String content = entity.getContent();
        if (content != null) {
            stmt.bindString(10, content);
        }
 
        Long categoryRecord = entity.getCategoryRecord();
        if (categoryRecord != null) {
            stmt.bindLong(11, categoryRecord);
        }
    }

    @Override
    protected final void bindValues(SQLiteStatement stmt, Categories entity) {
        stmt.clearBindings();
 
        String categoryId = entity.getCategoryId();
        if (categoryId != null) {
            stmt.bindString(1, categoryId);
        }
 
        String sourceId = entity.getSourceId();
        if (sourceId != null) {
            stmt.bindString(2, sourceId);
        }
 
        String sourceName = entity.getSourceName();
        if (sourceName != null) {
            stmt.bindString(3, sourceName);
        }
 
        String author = entity.getAuthor();
        if (author != null) {
            stmt.bindString(4, author);
        }
 
        String title = entity.getTitle();
        if (title != null) {
            stmt.bindString(5, title);
        }
 
        String desctiption = entity.getDesctiption();
        if (desctiption != null) {
            stmt.bindString(6, desctiption);
        }
 
        String url = entity.getUrl();
        if (url != null) {
            stmt.bindString(7, url);
        }
 
        String urlToImage = entity.getUrlToImage();
        if (urlToImage != null) {
            stmt.bindString(8, urlToImage);
        }
 
        String publishedAt = entity.getPublishedAt();
        if (publishedAt != null) {
            stmt.bindString(9, publishedAt);
        }
 
        String content = entity.getContent();
        if (content != null) {
            stmt.bindString(10, content);
        }
 
        Long categoryRecord = entity.getCategoryRecord();
        if (categoryRecord != null) {
            stmt.bindLong(11, categoryRecord);
        }
    }

    @Override
    public String readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getString(offset + 0);
    }    

    @Override
    public Categories readEntity(Cursor cursor, int offset) {
        Categories entity = new Categories( //
            cursor.isNull(offset + 0) ? null : cursor.getString(offset + 0), // categoryId
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // sourceId
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // sourceName
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // author
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // title
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5), // desctiption
            cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6), // url
            cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7), // urlToImage
            cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8), // publishedAt
            cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9), // content
            cursor.isNull(offset + 10) ? null : cursor.getLong(offset + 10) // categoryRecord
        );
        return entity;
    }
     
    @Override
    public void readEntity(Cursor cursor, Categories entity, int offset) {
        entity.setCategoryId(cursor.isNull(offset + 0) ? null : cursor.getString(offset + 0));
        entity.setSourceId(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setSourceName(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setAuthor(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setTitle(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setDesctiption(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
        entity.setUrl(cursor.isNull(offset + 6) ? null : cursor.getString(offset + 6));
        entity.setUrlToImage(cursor.isNull(offset + 7) ? null : cursor.getString(offset + 7));
        entity.setPublishedAt(cursor.isNull(offset + 8) ? null : cursor.getString(offset + 8));
        entity.setContent(cursor.isNull(offset + 9) ? null : cursor.getString(offset + 9));
        entity.setCategoryRecord(cursor.isNull(offset + 10) ? null : cursor.getLong(offset + 10));
     }
    
    @Override
    protected final String updateKeyAfterInsert(Categories entity, long rowId) {
        return entity.getCategoryId();
    }
    
    @Override
    public String getKey(Categories entity) {
        if(entity != null) {
            return entity.getCategoryId();
        } else {
            return null;
        }
    }

    @Override
    public boolean hasKey(Categories entity) {
        return entity.getCategoryId() != null;
    }

    @Override
    protected final boolean isEntityUpdateable() {
        return true;
    }
    
}
